% test of TIFF / DNG IFD reader
%
% read out and print all tags known the chronos cameras might write 
% into TIFF RAW, TIFF 8Bit or DNG files

clear

% my sample images, select your own
filename = 'D:/HighSpeedCam/Color/DNG 16Bit.dng';
%filename = 'D:/HighSpeedCam/Color/TIFF RAW.tiff';
%filename = 'D:/HighSpeedCam/Color/TIFF 8Bit.tiff';
%filename = 'D:/HighSpeedCam/Mono/DNG 16Bit.dng';
%filename = 'D:/HighSpeedCam/Mono/TIFF RAW.tiff';
%filename = 'D:/HighSpeedCam/Mono/TIFF 8Bit.tiff';

% open input file
fid = fopen(filename,'rb'); % optional add 'ieee-le'
if fid<0, error('file not found'); end

disp(filename);

disp('*** standard TIFF tags ***');
ImageWidth  = IFDdata(fid, hex2dec('100'))
ImageHeight  = IFDdata(fid, hex2dec('101'))
BitsPerSample  = IFDdata(fid, hex2dec('102')) 
Compression  = IFDdata(fid, hex2dec('103')) 
PhotometricInterpretation  = IFDdata(fid, hex2dec('106')) 
Make  = IFDdata(fid, hex2dec('10F')) % camera vendor
Model = IFDdata(fid, hex2dec('110')) % camera model
StripOffsets = IFDdata(fid, hex2dec('111')) % strip offset(s) - we expect just one
Orientation  = IFDdata(fid, hex2dec('112'))
SamplesPerPixel  = IFDdata(fid, hex2dec('115'))
RowsPerStrip  = IFDdata(fid, hex2dec('116'))
StripByteCounts = IFDdata(fid, hex2dec('117')) % data size in bytes
PlanarConfiguration = IFDdata(fid, hex2dec('11C'))
ResolutionUnit = IFDdata(fid, hex2dec('128'))
ExifIFD = IFDdata(fid, hex2dec('8769'))

if ExifIFD != 0
  disp('*** EXIF tags ***');
  ExifVersion = IFDdata(fid, hex2dec('9000'), ExifIFD)
  DateTimeDigitized = IFDdata(fid, hex2dec('9004'), ExifIFD)
  ExposureTime = IFDdata(fid, hex2dec('829A'), ExifIFD)
  BodySerialNumber = IFDdata(fid, hex2dec('A431'), ExifIFD)
  FrameRate = IFDdata(fid, hex2dec('C764'), ExifIFD)
end

disp('*** DNG tags ***');
CFARepeatPatternDim = IFDdata(fid, hex2dec('828D'))
CFAPattern = IFDdata(fid, hex2dec('828E'))
DNGVersion = IFDdata(fid, hex2dec('C612'))
DNGBackwardVersion = IFDdata(fid, hex2dec('C613'))
UniqueCameraModel = IFDdata(fid, hex2dec('C614'))
CFALayout = IFDdata(fid, hex2dec('C617'))
WhiteLevel = IFDdata(fid, hex2dec('C61D'))
ColorMatrix1 = IFDdata(fid, hex2dec('C621'));
if length(ColorMatrix1) == 9
  ColorMatrix1 = reshape(ColorMatrix1,3,3)'
else
  ColorMatrix1
end
AsShotNeutral = IFDdata(fid, hex2dec('C628'))
CalibrationIlluminant1 = IFDdata(fid, hex2dec('C65A'))

fclose(fid);