% decode a 8 Bit TIFF frame
clear
clf

subsample = 1; % simple size reduction for display, e.g. 2 or 4

% my sample images, select your own
switch 3
  case 3
    filename = 'D:/HighSpeedCam/Color/TIFF 8Bit.tiff';
  case 13
    filename = 'D:/HighSpeedCam/Mono/TIFF 8Bit.tiff';
end

% open input file
fid = fopen(filename, 'rb'); % optional add 'ieee-le'
if fid<0, error('file not found'); end

% get required information
hsize  = IFDdata(fid, 256) % hsize tag
vsize  = IFDdata(fid, 257) % vsize tag
BitsPerSample  = IFDdata(fid, hex2dec('102')) % length 3 for color data

% get actual image data
offset = IFDdata(fid, 273); % strip offset(s) - we expect just one
fseek(fid, offset); % start of image data

if length(BitsPerSample) == 3
  % color image
  frame = fread(fid, hsize*vsize*3, 'uint8')/255;
  img = zeros(vsize, hsize, 3);
  img(:,:,1) = reshape(frame(1:3:end), hsize, vsize)';
  img(:,:,2) = reshape(frame(2:3:end), hsize, vsize)';
  img(:,:,3) = reshape(frame(3:3:end), hsize, vsize)';
else
  img = fread(fid, hsize*vsize, 'uint8');
  img = reshape(img, hsize, vsize)';
end
fclose(fid);

img = img / max(max(max(img))); % optional scale according to brightest pixel component
imshow(img, [0 1]);
